<template>
  <v-container>
    <v-row>
      <v-col cols="3">
        <v-card-actions>
          <v-btn @click="doAdd">Add New</v-btn>
          <v-btn @click="doDownload" :disabled="statusProgress">Downlod Template</v-btn>
        </v-card-actions>
        <v-card-actions>
          <v-file-input label="Import GPON" ref="import" :disabled="statusProgress" show-size accept=".xls" @change="doUpload" />
        </v-card-actions>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <center>
          <h1>GPON</h1>
        </center>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="gpons"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <GponForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import {convertExcelTojson} from "../utils/util";
import GponForm from "../components/GponForm";
import service from "../service/GponService";
import FileSaver from 'file-saver'

export default {
  name: "Sto",
  components: {
    GponForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      gpons: [],
      gponsImport: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "REGIONAL", align: "center", value: "sto.witel.regional.nama", sortable: true },
        { text: "WITEL", align: "center", value: "sto.witel.nama", sortable: true },
        { text: "STO", align: "center", value: "sto.nama", sortable: true },
        { text: "NMS", align: "center", value: "nms.nama", sortable: true },
        { text: "HOSTNAME", align: "center", value: "hostname", sortable: true },
        { text: "IP ADDRESS", align: "center", value: "ip_address", sortable: true },
        { text: "VLAN INTERNET", align: "center", value: "vlan_inet", sortable: true },
        { text: "VLAN VOICE", align: "center", value: "vlan_voice", sortable: true },
        { text: "CREATE DATE", align: "center", value: "create_at", sortable: true },
        { text: "UPDATE DATE", align: "center", value: "update_at", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doDownload() {
      this.statusProgress = true
      let filename = 'template_import_gpon.xls'
      await service.doDownload(filename).then(res => {
        FileSaver.saveAs(res.data, filename)
      }).catch(err => {
        console.log(err)
        console.log(err.response)
        this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
      })
      this.statusProgress = false
    },
    async doUpload(files) {
      if (files != null) {
        this.statusProgress = true
        if (files.type !== 'application/vnd.ms-excel') {
          this.$refs.dlgMsg.doOpenMsg('File Harus Excel 97-2003')
          return
        } else if (files.size > 20971520) {
          this.$refs.dlgMsg.doOpenMsg('Ukuran File Tidak Boleh Lebih Dari 20MB')
          return
        }

        await convertExcelTojson(files, 2).then(async res => {
          let gpons = res
          this.gponsImport = []
          let i = 0
          for (let gpon of gpons) {
            let isValid = await this.validation(gpon, i + 1)
            if (!isValid) {
              return
            }
            let gponImport = {
              ip_address: gpon.ip_address.trim(),
              hostname: gpon.hostname.toUpperCase(),
              vlan_inet: gpon.vlan_inet,
              vlan_voice: gpon.vlan_voice.trim(),
              default_user_nms: gpon.default_user_nms.toString().toLowerCase().trim() === 'true',
              username: gpon.username,
              password: gpon.password,
              nms: {
                ip_server: gpon.nms.trim()
              },
              sto: {
                alias: gpon.sto.toUpperCase().trim(),
                witel: {
                  alias: gpon.witel.toUpperCase().trim(),
                  regional: {
                    id: gpon.regional.toUpperCase().trim(),
                  },
                },
              },
            }
            this.gponsImport.push(gponImport)
          }
        }).catch(err => {
          console.log(err)
          this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION CONVERT EXCEL TO JSON`)
          this.statusProgress = false
        })
        await service.storeBatch(this.gponsImport).then(async res => {
          let {status, message} = res.data
          if (status === 'SUCCESS') {
            await this.doRefresh()
          }
          this.$refs.dlgMsg.doOpenMsg(message)
        }).catch(err => {
          console.log(err)
          this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION BATCH SAVE GPON`)
          this.statusProgress = false
        })
        this.statusProgress = false
      }
    },
    validation(gpon, row) {
      if (gpon.hostname == null || gpon.hostname === '') {
        this.$refs.dlgMsg.doOpenMsg(`Hostname Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.ip_address == null || gpon.ip_address === '') {
        this.$refs.dlgMsg.doOpenMsg(`IP Address Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.vlan_inet == null || gpon.vlan_inet === '') {
        this.$refs.dlgMsg.doOpenMsg(`VLAN Internet Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.vlan_voice == null || gpon.vlan_voice === '') {
        this.$refs.dlgMsg.doOpenMsg(`VLAN Voice Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.nms == null || gpon.nms === '')  {
        this.$refs.dlgMsg.doOpenMsg(`NMS Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.sto == null || gpon.sto === '') {
        this.$refs.dlgMsg.doOpenMsg(`STO Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.witel == null || gpon.witel === '') {
        this.$refs.dlgMsg.doOpenMsg(`Witel Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.regional == null || gpon.regional === '') {
        this.$refs.dlgMsg.doOpenMsg(`Regional Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.default_user_nms == null || gpon.default_user_nms === '') {
        this.$refs.dlgMsg.doOpenMsg(`Default User NMS Harus Diisi Pada Baris ${row}`)
        return false
      } else if (gpon.default_user_nms.toString().toLowerCase() !== 'true') {
        if (this.username == null || this.username === '') {
          this.$refs.dlgMsg.doOpenMsg(`Username Gpon Harus Diisi Pada Baris ${row}`)
          return false
        } else if (this.password == null || this.password === '') {
          this.$refs.dlgMsg.doOpenMsg(`Password Gpon Harus Diisi Pada Baris ${row}`)
          return false
        }
      }
      return true
    },
    doAdd() {
      let title = "Add New GPON"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data GPON ${data.hostname}(${data.ip_address})`)) {
        return false;
      }
      this.statusProgress = true
      await service.delete(data.id).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
      })
      this.statusProgress = false
    },
    doEdit(id) {
      let title = "Edit GPON"
      this.$refs.dlg.doEdit(id, title, true)
    },
    async doRefresh() {
      this.statusProgress = true
      await service.getAll()
        .then(res => {
          this.gpons = res.data.data
        })
      this.statusProgress = false
    }
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>